﻿using System;
using System.Collections.Generic;
using System.Text;

namespace _02_UbgKlasseTime
{
    // ToDo: Schreiben Sie die zwei Klassen Time und TimeSpan, sodass nachfolgendes Programm ausführbar ist
    // Sie können die Uhrzeit und die Zeitspanne intern gerne durch einen int realisieren und
    // nur für die Ausgaben in tatsächliche Std:Min-Ausgaben umwandeln.

    // Klasse Time, Konstruktor(int,int)
    // Time.op+(Time,TimeSpan),

    // Time:string->Time, evtl. Time.Time(string)
    // Time.op true&false
    // Time.op== & Time.op!= 
    // override Time.ToString()

    // TimeSpan:string->TimeSpan (impl),
    // TimeSpan:int->TimeSpan (impl.)
    // TimeSpan.op-(Time, Time) ->TimeSpan



    // TimeSpan.TotalMins-get-Property
    // override TimeSpan.ToString()


    // 11:30
    // 105
    // 1:45
    // Guten Morgen
    // Die Uhrzeiten sind gleich!
    class Time
    {
        int minuten;
        public Time(int std, int min)
        {
            minuten = std * 60 + min;
        }
        private Time (int mins) { minuten = mins; }
        
        // Konvertierungskonstruktoren:
        public static implicit operator Time(string s)
        {
            string[] t = s.Split(':');
            return new Time (Convert.ToInt32(t[0]),Convert.ToInt32(t[1]));
        }
        public static implicit operator Time(int k) => new Time(k);

        public static TimeSpan operator -(Time t1, Time t2) => new TimeSpan(t2.minuten - t1.minuten);
        public static Time operator +(Time t1, Time t2) => new Time(t1.minuten + t2.minuten);
        public static bool operator ==(Time t1, Time t2) => t1.minuten == t2.minuten;
        public static bool operator !=(Time t1, Time t2) => !(t1==t2);
    }

    class TimeSpan
    {
        int minuten;
        public TimeSpan(int mins) { minuten = mins; }
        public int TotalMins { get => minuten; }

    }
}
