﻿using System;
using System.Collections.Generic;
using System.Text;

namespace _03_UbgKlasseTime_Mo
{
    class Time
    {
        int time;
        
        public Time(int stunden, int minuten)
        {
            time = stunden * 60 + minuten;
        }

        private Time(int minuten)
        {
            time = minuten;
        }

        public static implicit operator Time(string s)
        {
            string[] d = s.Split(':');
            return new Time(Convert.ToInt32(d[0]), Convert.ToInt32(d[1]));
        }
        public static implicit operator Time (int k) => new Time(k);
        //public static implicit operator bool(Time t) => t.time < 12*60;
        public static bool operator true(Time t) => t.time < 12 * 60;
        public static bool operator false(Time t) => t.time >= 12 * 60;

        public static Time operator +(Time t1, Time t2) => new Time(t1.time + t2.time);
        public override string ToString() => $"{time / 60}:{time % 60}";
        public static TimeSpan operator -(Time t2, Time t1)
            => new TimeSpan(t2.time-t1.time);
        public static bool operator ==(Time t1, Time t2) => t1.time == t2.time;
        public static bool operator !=(Time t1, Time t2) => !(t1==t2);
    }

    class TimeSpan
    {
        int span;
        public TimeSpan(int minuten) { span = minuten; }

        public int TotalMins { get => span; }
        public override string ToString() => $"{span / 60}:{span % 60} Stunden:Mins";
    }
}
