﻿using System;
using System.Collections.Generic;
using System.Text;

namespace _03_UbgListe_Di
{
    class LItem
    {
        public string toDo;
        public LItem next;
        public LItem (string ToDo) { toDo = ToDo;next = null; }
    }
    class ToDoListe
    {
        LItem anf = null, ende = null;
        int anz = 0;

        public void Add(string todo)
        {
            LItem neu = new LItem(todo);
            anz++;

            if (anf == null)
                anf = ende = neu;
            else
            {
                ende.next = neu;
                ende = neu;
            }
        }
        public string [] GetAll()
        {
            if (anz == 0)
                return null;

            string[] res = new string[anz];
            int i = 0;
            for (LItem item = anf; item != null; item=item.next)
                res[i++] = item.toDo;
            return res;
        }
        public IEnumerator<string> GetEnumerator()
        {
            for (LItem item = anf; item != null; item = item.next)
                yield return item.toDo;
        }
        public string this[int ind]
        {
            get
            {
                LItem item = anf;
                for (int i = 0; i < ind; i++)
                    item = item.next;
                return item.toDo;
            }
        }

    }
}
