﻿using System;

namespace _05_2_IntroVererbungKfz
{
    //Kraftfahrzeuge:
    //
    //Steuerberechnung PKW:
    //Hubraumsteuer
    //Den Anteil für den Hubraum berechnen Sie dabei anhand der von der Motorenart abhängigen Hubraumsteuer:

    //Motorenart Steuern pro angefangenen 100 Kubikzentimetern Hubraum
    //Benzin- / Ottomotor	2,00 Euro
    //Dieselmotor 9,50 Euro
    //Datenquelle: Bundesfinanzministerium

    //Ein Dieselfahrzeug mit einem Motorhubraum von 1.500 ccm kostet folglich 142,50 Euro Hubraumsteuer.

    //CO2-Steuer
    //Zusätzlich wird die Steuer für den CO2-Ausstoß berechnet. Jedes Gramm CO2-Ausstoß pro Kilometer, das über 
    //dem Sockelwert liegt, kostet zwei Euro Steuern. Die Sockelwerte – „Freibeträge“ für unterschiedliche 
    //Zeitpunkte der Erstzulassung – können Sie der folgenden Tabelle entnehmen ...
    //----------

    // Steuerberechnung Motorrad
    // Wie hoch ist die Steuer für Krafträder über 125 ccm?
    // Je angefangene 25 ccm Hubraum müssen Sie jährlich eine Kfz-Steuer von 1,84 Euro entrichten.
    //
    // Steuerberechnung LKW
    //Ein Lkw unterliegt der Kraftfahrzeugsteuer und muss besteuert werden
    //Beim Lkw wird eine Steuer über Gewicht und andere Bedingungen erhoben
    //Lkw-Steuer richtet sich auch nach Schadstoffklassen und Geräuschklassen
    //Der Höchstsatz für die günstigste Lkw-Steuerklasse beträgt 556,00 Euro

    // Steuerberechnung EScouter
    // 15€ pro Jahr

    class Program
    {
        static void Main(string[] args)
        {
            #region OldStyle
            //Pkw[] pkw = new Pkw[1000];
            //LKW[] lkw = new LKW[1000];
            //Motorrad[] motorrad = new Motorrad[1000];

            //Console.WriteLine("Neues Fahrzeug anlegen (0=PKW, 1=LKW, 2=Motorrad");
            //int auswahl = Convert.ToInt32(Console.ReadLine());
            //if (auswahl == 0)
            //    pkw[10] = new Pkw();
            //else if (auswahl == 1)
            //    lkw[47] = new LKW();
            //pkw[1].Steuern();
            //lkw[1].Steuern();
            //motorrad[1].Steuern();
            #endregion
            Kfz[] kfz = new Kfz[1000];
            kfz[0] = new LKW("N-AB 123", 3500, 5000);
            kfz[1] = new Pkw(1599, 2, "ER-XY 456");
            kfz[2] = new Motorrad("FÜ-CD 789",250);
            kfz[3] = new Tieflader("AN-345", 20000, 4500, 12000);

            // kfz[4] = new Kfz("XX-123");
            // Keine Objekte einer abstrakten Klasse anlegbar!

            //Console.WriteLine((kfz[0] as LKW).Steuern());
            //Console.WriteLine(((Pkw)kfz[1]).Steuern());
            //Console.WriteLine(((Motorrad)kfz[2]).Steuern());

            for (int i = 0; i < 5; i++)
            {
                #region Lästige explizite Konvertierungen
                //if (kfz[i] is LKW)
                //    Console.WriteLine((kfz[i] as LKW).Steuern());
                //else if (kfz[i] is Pkw)
                //    Console.WriteLine(((Pkw)kfz[i]).Steuern());
                //else if (kfz[i] is Motorrad)
                //    Console.WriteLine(((Motorrad)kfz[i]).Steuern());
                #endregion
                Console.WriteLine(kfz[i].Steuern());
                if (kfz[i] is Pkw)
                    Console.WriteLine((kfz[i] as Pkw).CO2Wert());
            }
            #region Statischer vs. dynamischer Typ einer Variablen
            // Statischer Typ ~ der angegebene Typ einer Variablen
            // kfz k -- kfz ist der statische Typ
            // Dynamischer Typ ~ der tatsächliche Typ des darin gespeicherten Objekts
            // kfz k = new Pkw -- Pkw ist der dynamische Typ
            //
            // Der STATISCHE TYP entscheidet über die Methodenauswahl, wenn kein virtual angegeben ist
            // UND die zur Verfügung stehenden Methoden
            //
            // Bei virtual entscheidet der dynamische Typ
            #endregion
        }
    }
}
