﻿using System;
using System.Collections.Generic;
using System.Text;

namespace _06_UbgVererbung_Di
{
    //Schreiben Sie drei Klassen Dreieck, Rechteck und Kreis mit jeweils einem Konstruktor
    //    Dreieck (int p1x, int p1y, int p2x, int p2y, int p3x, int p3y)
    //    Rechteck(int topX, int topY, int width, int height)
    //    Circle(int x, int y, int r)
    // Erstellen Sie in Main() EIN Feld in dem Sie diese Objekte miteinander speichern können -
    // hierfür ist die Erstellung einer gemeinsamen Basisklasse GrafischesObjekt erforderlich -
    // und schreiben Sie eine for/foreach-Schleife, die für die jeweiligen Feldeinträge
    // die entsprechende Ausgabe()-Methode aufruft. Hier reicht es aus, z.B. einfach Kreis(x,y,r) 
    // auszugeben.
    class GrObjekt 
    {
        public virtual void Ausgabe() { Console.WriteLine("ERROR"); }
        // virtual ~ kann/muss-nicht überschrieben werden
        // abstract ~ muss überschrieben werden
    }
    class Dreieck:GrObjekt  // Dreieck ist-ein GrObjekt
    {
        int p1x, p1y, p2x, p2y, p3x, p3y;
        public Dreieck(int p1x, int p1y, int p2x, int p2y, int p3x, int p3y)
        {
            this.p1x = p1x; this.p1y = p1y;
            this.p2x = p2x; this.p2y = p2y;
            this.p3x = p3x; this.p3y = p3y;
        }
        public override void Ausgabe()
        {
            Console.WriteLine($"Dreieck ({p1x},{p1y}), ({p2x},{p2y}), ({p3x},{p3y})");
        }
    }
    class Rechteck : GrObjekt
    {
        int topX,  topY,  width,  height;
        public Rechteck(int topX, int topY, int width, int height)
        {
            this.topX = topX; this.topY = topY; 
            this.width = width;this.height = height;
        }
        public override void Ausgabe()
        {
            Console.WriteLine($"Rechteck ({topX},{topY}), Breite: {width}, Höhe: {height}");
        }
    }
    class Circle : GrObjekt
    {
        int x,  y,  r;
        public Circle(int x, int y, int r)
        {
            this.x = x; this.y = y; this.r = r;
        }
        public override void Ausgabe()
        {
            Console.WriteLine($"Kreis ({x},{y}), Radius: {r}");
        }
    }
}
