﻿using System;
using System.Runtime.Serialization;

namespace _08_UbgExceptionsDi
{
    // Erstellen Sie eine Dummy-Methode Funktion1, die einen try-catch Block enthält und 
    // eine zweite Dummy-Methode Funktion2, die wiederum einen try-catch Block besitzt und
    // eine Methode Funktion3, die bei ihrem Aufruf einen throw mit einer selbst
    // erstellten Fehlerklasse zur Folge hat.
    // Main ruft Funktion1, Funktion1 ruft Funktion2 
    // und Funktion2 ruft Funktion3. Setzen Sie hinter die catches jeweils ein finally
    // Schreiben Sie entsprechende catch-Methoden, werfen Sie den Fehler weiter
    // und stellen Sie sicher, dass das Programm unter keinen Umständen mit einer Exception beendet wird!

    class Program
    {
        static void Main(string[] args)
        {
            try
            {
                Console.WriteLine("Main: Vor Aufruf der Funktion1");
                Funktion1();
                Console.WriteLine("Main: Nach Aufruf der Funktion1");
            }
            catch (Exception) { Console.WriteLine("Hier ist noch etwas schief gegangen"); }
        }
        static void Funktion1()
        {
            try
            {
                Console.WriteLine("Funktion 1 vor Aufruf von F2");
                Funktion2();
                Console.WriteLine("Funktion 1 nach Aufruf von F2");
            }
            catch (MeinFehler)
            {
                Console.WriteLine("Funktion 1 - catch MeinFehler");
            }
            finally
            {
                Console.WriteLine("Funktion 1 - finally");
            }
            Console.WriteLine("Funktion 1 - Ende");
        }

        static void Funktion2()
        {
            try
            {
                Console.WriteLine("Funktion 2 vor Aufruf von F3");
                Funktion3();
                Console.WriteLine("Funktion 2 nach Aufruf von F3");
            }
            catch (MeinFehler)
            {
                Console.WriteLine("Funktion 2 - catch MeinFehler");
                throw;
            }
            finally
            {
                Console.WriteLine("Funktion 2 - finally");
            }
            Console.WriteLine("Funktion 2 - Ende");
        }
        static void Funktion3()
        {
            Console.WriteLine("Funktion 3 vor Aufruf von throw");
            throw new MeinFehler("Mein Fehler aus Funktion 3",12);
            //Console.WriteLine("Funktion 3 nach Aufruf von throw");
        }
        
    }

    
    class MeinFehler : Exception
    {
        public int Fehlercode { get; private set; }

        
        public MeinFehler(string message, int Fehlercode) : base(message)
        {
            this.Fehlercode = Fehlercode;
        }     
       
    }
}
