﻿using System;
using System.Collections.Generic;

namespace _09_2_GenericSplitArray
{
    class Program
    {
        static T[] SplitArray<T>(T[] arr, T limit) where T:IComparable<T>
        {
            List<T> res = new List<T>();
            foreach (var item in arr)
            {
                if (item.CompareTo(limit) >= 0)
                    res.Add(item);
            }
            return res.ToArray();
        }


        static void Main(string[] args)
        {
            int [] f = { 10, 30, 20, 45, 50, 80 };
            int[] r = SplitArray<int>(f, 30);
            foreach (var item in r)
            {
                Console.WriteLine(item);
            }
        }
    }
}
