﻿using System;
using System.Collections.Generic;
using System.Text;

namespace _10_1_DelegateVariable
{
    delegate void MyFunction(string s);
    class Button
    {
        public event  MyFunction Callback;
        // event ~ Einschränkung der Zugriffsmöglichkeiten von 
        //   außerhalb der Klasse auf nur noch += bzw. -=

        public void Print(string s)
        {
            // Vorarbeiten
            // Callback(s);
            Callback?.Invoke(s);  // ?. ~ (Callback==null) ? null : Callback.Invoke(s)
            // print = null; ~ Nur innerhalb der Klasse erlaubt
            // Nacharbeiten
        }
        // Console.WriteLine(s);
        // AusgabeInGrossbuchstaben(s);
        //  :
    }
    
}
