﻿using System;

namespace _10_1_DelegateVariable
{
    class Program
    {
        static void AusgabeInGrossbuchstaben(string s)
        {
            Console.WriteLine(s.ToUpper());
        }
        static void AusgabeInKleinbuchstaben(string s)
        {
            Console.WriteLine(s.ToLower());
        }
        static void Main(string[] args)
        {
            Button t1 = new Button();
            Button t2 = new Button();

            t1.Print("Erster Versuch");

            t1.Callback += Console.WriteLine;
            t1.Callback += AusgabeInGrossbuchstaben;
            t1.Callback += AusgabeInKleinbuchstaben;
            t1.Callback += delegate (string s) { Console.WriteLine($"*** {s} ***"); };
            t1.Callback += s => { Console.WriteLine($"--- {s} ---"); };
            //t1.print -= AusgabeInGrossbuchstaben;
            //t1.print += t1.print;

            //t1.print -= s => { Console.WriteLine($"--- {s} ---"); };
            // Anonyme Methoden & Lambda-Ausdrücke können nicht aus der Liste entfernt werden!

            t1.Print("Hallo");
            // t1.Callback("Hallo"); //~ Direkter Aufruf der Delegate-Var ist bei event nicht erlaubt

            // t2.print += t1.print; Ebenfalls nicht erlaubt
            //t2.Print("Welt");
        }
    }
}
