﻿using System;

namespace _10_1_GenerischeListeMitSuche
{
    class Kontakt : IComparable<Kontakt>
    {
        public string Name { get; set; }
        public string Adr { get; set; }
        public Kontakt(string name, string adr)
        { Name = name;Adr = adr; }
        public override string ToString()
        => $"Name: {Name}   Adresse: {Adr}";
        public int CompareTo(Kontakt other) => Name.CompareTo(other.Name);
    }
    class Program
    {
        static bool IstGeradeTest(int x) => x % 2 == 0;
        static void Main(string[] args)
        {
            Liste<int> intListe = new Liste<int>();
            intListe.AddEnd(10);
            intListe.AddEnd(11);
            intListe.AddEnd(12);
            intListe.AddEnd(13);
            intListe.AddEnd(14);

            //foreach (var item in intListe.GeradeZahlen())
            //foreach (var item in intListe.Filter(IstGeradeTest))   // int --> bool
            //foreach (var item in intListe.Filter(x => x % 2 == 0))    // nur gerade Zahlen
            //foreach (var item in intListe.Filter(x => x >= 12))       // >=12
            foreach (var item in intListe.Filter(x => true))
            {
                Console.WriteLine(item);
            }


            Liste<string> freunde = new Liste<string>();
            freunde.AddEnd("Anton");
            freunde.AddEnd("Berta");
            freunde.AddEnd("Claudia");
            freunde.AddEnd("Dieter");
            foreach (var item in freunde.Filter(x => x.StartsWith("B")))
            {
                Console.WriteLine(item);
            }


            Liste<Kontakt> adressen = new Liste<Kontakt>();
            adressen.AddEnd(new Kontakt("Praesident", "Keßlerplatz 12"));
            adressen.AddEnd(new Kontakt("Dekan-IN", "Hohfederstraße 40"));
            adressen.AddEnd(new Kontakt("Dekan-AMP", "Keßlerplatz 12"));
            foreach (var item in adressen.Filter(x => x.Adr.Contains("12")))
            {
                Console.WriteLine(item);
            }
        }
    }
}
