﻿using System;
using System.Linq;

namespace _11_3_Erweiterungsmethoden
{
    public static class Erweiterung
    {
        public static int Abs(this int i)
         => (i > 0) ? i : -i;

        public static T[] Sortieren<T> (this T[] feld) where T:IComparable<T>
        {
            // ... Hier Ihre Sort-Methode
            Array.Sort(feld);
            return feld;
        }
    }
    class Program
    {
        static void Main(string[] args)
        {
            int ix = -25;
            //Console.WriteLine(ix.Abs());

            int[] ints = { 10, 45, 15, 38, 21, 26 };
            var res = ints.Sortieren();
            foreach (var item in res)
            {
                Console.WriteLine(item);
            }

            Console.WriteLine("---------");
            var res2 = ints.OrderBy(g=>-g);
            foreach (var item in res2)
            {
                Console.WriteLine(item);
            }
        }
    }
}
