﻿using System;
using System.Collections.Generic;
using System.Text;

namespace _11_Ubg_Mailverteiler_Di
{
    // Legen Sie ein Delegate void Callback(string s) an
    // Erstellen Sie eine Klasse MessageBox mit
    //   - Einem Event Verteiler
    //   - Einer Methode Send(string s), welche die verteiler Variable aufruft

    // Experimentieren Sie ...
    //  1) Legen Sie zwei Dummy-Klassen ClassA und ClassB an. Beide Klassen sollen öffentliche Methoden
    //     (statisch/nicht-statisch) besitzen, die der Callback-Signatur entsprechen
    //  2) Definieren Sie auch in Main noch eine statische Methode, die der Callback-Signatur entspricht
    //  3) Legen Sie eine Instanz der MessageBox an und registrieren Sie die Methoden in der Event-Variablen
    //  4) Rufen Sie Send() mit einem Text auf
    //  5) Entfernen Sie eine der registrierten Methoden und geben Sie noch einen Text aus

    class MessageBox
    {
        public delegate void Callback(string s);
        public delegate void TransformDel(ref string s);

        public event Callback Verteiler;
        public event TransformDel Transformationen;

        public void Send(string s)
        {
            Transformationen?.Invoke(ref s);
            Verteiler?.Invoke(s);
        }
    }
}
