﻿using System;
using System.Collections.Generic;
using System.Text;

namespace _01_3_Personalausweis
{
    public class Buergeramt
    {
        Personalausweis[] Amt;
        int kapazitaet;

        public Buergeramt(int Kapazitaet)
        {
            Amt = new Personalausweis[Kapazitaet];
            kapazitaet = Kapazitaet;
        }

        public Personalausweis this[int index]
        {
            get => Amt[index];
            set
            {
                if (index >= 0 && index < kapazitaet && Amt[index] == null)
                    Amt[index] = value;
                else throw new Exception("Index außerhalb des Wertebereichs oder Feldplatz bereits belegt.");
            }
        }

        public IEnumerator<Personalausweis> GetEnumerator()
        {
            for (int i = 0; i < kapazitaet; i++)
            {
                if (Amt[i] != null)
                    yield return Amt[i];
            }
        }
    }

}
