﻿using System;
using System.Collections.Generic;
using System.Text;

namespace _04_UbgCycleList_Di
{
    // Schreiben Sie eine verkettete Liste, die die Möglichkeit bietet,
    // das letzte Element wieder mit dem ersten zu verbinden (Zyklus schließen)
    // Eingebettete Klasse Element
    // Nutzlast: string name
    // Methoden:
    
    class CycleList
    {
        class LItem
        {
            public string name;
            public LItem next;
            public LItem(string Name) { name = Name; next = null; }
        }
        LItem first = null, last = null;
        LItem iterator;

        public void AddEnd(string Name) // wie bisher
        {
            LItem newItem = new LItem(Name);
            if (first == null)
                first = last = newItem;
            else
            {
                last.next = newItem;
                last = newItem;
            }
        }
        public void  CloseCycle() // letztes mit dem ersten Element verbinden
        {
            last.next = first;
        }
        public void Print()
        {
            if (first == null)
                return;
            //Wir wissen hier: Es gibt mindestens ein Element
            LItem item = first;
            do
            {
                Console.WriteLine(item.name);
                item = item.next;
            } while (item != first);
        }


        public void  SetIterator(int offset=0) // Einen internen Zeiger (Iterator) auf das (anfang+offset) Listenelement setzen
        {
            iterator = first;
            for (int i = 0; i < offset; i++)
                iterator = iterator.next;
        }
        public string GetName() // Den string zurückliefern, der im Iterator-Listenelement gespeichert ist
            => iterator.name;
        public void  MoveNext() // Den Iterator um ein Element weitersetzen
        {
            iterator = iterator.next;
        }
    }
}
