﻿using System;

namespace _07_1_Intro_Interfaces
{
    class Program
    {
        static void Main(string[] args)
        {
            //IBesteuerbar k=null;
            //k.Steuern();

            Pkw p = new Pkw();
            // p = new Motorrad();  geht nicht, da ein Motorrad kein Pkw ist (wohl aber Kfz)

            Kfz kfz = new Pkw();
            //kfz = new Motorrad();
            kfz.Fahren();

            IVerkaufbar[] verkObj = new IVerkaufbar[3];
            verkObj[0] = new Sportwagen();
            verkObj[1] = new Pkw();
            verkObj[2] = new Immobilien();

            foreach (var item in verkObj)
            {
                Console.WriteLine(item);
                item.Verkaufen();
                Console.WriteLine($"Steuern: {(item as Pkw).Steuern()}");
            }

            IBesteuerbar[] bestObj = new IBesteuerbar[2];
            //int ind = 0;
            for (int i = 0; i < verkObj.Length; i++)
            {
                if (verkObj[i] is IBesteuerbar item)
                    //bestObj[ind++] = item;
                    Console.WriteLine(item.Steuern());
            }

            foreach (var item in bestObj)
            {
                Console.WriteLine(item.Steuern());
            }

        }
    }
}
