﻿using System;

namespace _07_UbgWarenwirtschaft
{
    class Program
    {
        static void Main(string[] args)
        {
            Produkt[] produkte = new Produkt[3];
            produkte[0] = new Pflanzen(10, 0.35, "Geranien", Pflanzen.Pflanzentyp.zier);
            produkte[1] = new Pflanzen(10, 0.55, "Salat", Pflanzen.Pflanzentyp.nutz);
            foreach (var item in produkte)
            {
                Console.WriteLine(item.Wert());
                if (item.Name == "Geranien")
                {
                    // item.Giessen(); geht nicht, da die Basisklasse Produkt keine Methode Gießen enthält!!!

                    //if (item is Pflanzen)
                    //{
                    //   Pflanzen p = (Pflanzen)item;
                    //          ( ) liefert Fehler, wenn Konvertierung nicht möglich ist
                    //   p.Giessen();
                    //}

                    //Pflanzen p2 = item as Pflanzen;
                    //          as liefert "null", wenn Konvertierung nicht möglich ist
                    //p2.Giessen();

                    if (item is Pflanzen p3)
                        p3.Giessen();

                    (item as Pflanzen)?.Giessen();
                    // Konvertiere item zu Pflanze; wenn erfolgreich (d.h. != null) wird Giessen aufgerufen
                }
            }
        }
    }
}
