﻿using System;

namespace _08_3_GenericList
{

    class Program
    {
        static void Main(string[] args)
        {
            Liste<int> il1 = new Liste<int>();
            il1.AddSorted(10);
            il1.AddSorted(90);
            il1.AddSorted(60);
            il1.AddSorted(30);
            il1.AddSorted(80);
            il1.AddSorted(20);
            il1.Print();


            Liste<int> il2 = new Liste<int>();
            il2.AddSorted(100);
            il2.AddSorted(900);
            il2.AddSorted(600);
            il2.AddSorted(300);
            il2.Print();


            Liste<string> sl = new Liste<string>();
            sl.AddSorted("Berta");
            sl.AddSorted("Dieter");
            sl.AddSorted("Emil");
            sl.AddSorted("Claudia");
            sl.AddSorted("Anton");
            sl.Print();
            foreach (var item in sl)
            {
                Console.WriteLine();
            }

            //Liste<object> ol = new Liste<object>();
            //ol.AddEnd(1);
            //ol.AddEnd(3.14);
            //ol.AddEnd("Hallo");

            Liste<Person> pl = new Liste<Person>();
            pl.AddSorted(new Person("Meier", "Berta"));
            pl.AddSorted(new Person("Meier", "Anton"));
            pl.AddSorted(new Person("Huber", "Claudia"));
            pl.Print();


            Liste<Liste<int>> ll = new Liste<Liste<int>>();
            ll.AddSorted(il1);
            ll.AddSorted(il2);
            ll.Print();


            Liste<Kfz> kl = new Liste<Kfz>();
            kl.AddSorted(new Pkw(1599, 100, "N-AB 123"));
            kl.AddSorted(new Motorrad("ER-X 534", 250));
            kl.AddSorted(new LKW("FÜ-MN 543", 20000, 5000));
            kl.Print();

            //foreach (var item in kl)
            foreach (var item in kl.Reverse())
            {
                Console.WriteLine(item);
            }
        }
    }
}
