﻿using System;
using System.Linq;

namespace _11_4_LINQ_Intro
{
    class AnonymeVariableImProperty
    {
        public int MeinProperty { get; set; }
    }

    class AnonymeTypen
    {
        public static void AnonymousTypes()
        {
            #region var
            var x = "123";
            //x = 123;

            object o = 123;
            o = "123";
            #endregion
            var r1 = new { Name = "Wienkop", Tel = 1614, Adr = "Hohfederstraße 40" };
            var r2 = new { Name = "Wienkop", Tel = 1614};

            Console.WriteLine(r1);
            Console.WriteLine(r2.Name);
            // r1.Name = r2.Name;   Nicht zulässig, die Properties sind read-only!

            var r3 = new { Name = r1.Name, AdrLaenge = r1.Adr.Length };
            Console.WriteLine(r3);
        }
    }
    class Program
    {
        static void Main(string[] args)
        {
            // AnonymeTypen.AnonymousTypes();

            string[] wörter = {
                                  "Anton", "Berta", "Charles", "Dieter", "Emma", "Franz", "Gustav", "Heiner", "Ida",
                                  "Johanna", "Klaus", "Ludwig", "Manni", "Norbert", "Otto", "Paul", "Quasimodo", "Rainer",
                                  "Stefan", "Thorsten", "Uwe", "Victoria", "Willi", "Xaver", "Yvonne", "Zacharias"
                              };
            //var r1 = from w in wörter
            //         where w.Length < 6
            //         orderby w descending
            //         select new { OrgName = w, GrossName = w.ToUpper(), Länge = w.Length };
            //foreach (var item in r1)
            //{
            //    Console.WriteLine(item);
            //}

            var r2 = from w in wörter
                     where w.Length < 7
                     group w by w.Length;
            foreach (var group in r2)
            {
                Console.WriteLine($"Länge: {group.Key}");
                foreach (var item in group)
                {
                    Console.WriteLine(item);
                }
            }
        }
    }
}
