﻿using System;

namespace _12NewOverride
{
    class Base
    {
        public virtual void DoItOverride() { Console.WriteLine("Base.DoItOverride"); }
        public virtual void DoItNew() { Console.WriteLine("Base.DoItNew"); }
    }
    class Abgeleitet : Base
    {
        public override void DoItOverride() { Console.WriteLine("Abgeleitet.DoItOverride"); }
        public virtual new void DoItNew() { Console.WriteLine("Abgeleitet.DoItNew"); }
    }
    class AbgeleitetAbgeleitet : Abgeleitet
    {
        public override void DoItOverride() { Console.WriteLine("AbgelAbgel.DoItOverride"); }
        public new void DoItNew() { Console.WriteLine("AbgelAbgel.DoItNew"); }
    }
    
    class Program
    {
        static void Main(string[] args)
        {
            Abgeleitet a1 = new Abgeleitet();
            a1.DoItOverride();
            a1.DoItNew();
            Console.WriteLine();

            Base b1 = a1;
            b1.DoItOverride();
            b1.DoItNew();
            Console.WriteLine();

            Abgeleitet c1 = new AbgeleitetAbgeleitet();
            c1.DoItOverride();
            c1.DoItNew();
        }
    }
}
