﻿using System;

namespace _12_3_VererbungRedo
{
    class Basis
    {
        public virtual void Ausgabe(string s)
        {
            // virtual ~ Diese Methode KANN in abgeleiteten Klassen überschrieben werden
            // abstract ~ Diese Methode MUSS in abgeleiteten Klassen überschrieben werden!
            //            Hier keine Implementierung!
            Console.WriteLine("Ausgabe: "+s);
        }
    }

    class PKW:Basis
    {
        public override void Ausgabe(string s)
        {
            Console.WriteLine("Meine wunderschöne PKW-Ausgabe "+s);
        }
    }
    class LKW : Basis
    {
        public override void Ausgabe(string s)
        {
            Console.WriteLine("Meine wunderschöne LKW-Ausgabe " + s);
        }
    }
    class Program
    {
        static void Main(string[] args)
        {
            Basis[] f = new Basis[5];
            f[0] = new PKW();
            f[1] = new LKW();
            f[0].Ausgabe("Hallo");
            // Ohne virtual:
            // Methodenauswahl gemäß des statischen Typs (hier: Basis)
            //(f[0] as PKW).Ausgabe2("Hallo");

            // Mit virtual plus override:
            // Methodenauswahl gemäß des dynamischen Typs (hier: PKW.Ausgabe())
            f[1].Ausgabe("Hallo2");

        }
    }
}
