﻿using System;

namespace _12_UbgTransformingServer
{
    class Client
    {
        public string Name { get; }
        public Client(string Name) { this.Name = Name; }

        // ToDo: statische "Listener" Methode
        public static void Ausgabe(string s)
        {
            Console.WriteLine("static: "+s);
        }
        // ToDo: nicht-statische "Listener" Methode
        public void Listener(string s)
        {
            Console.WriteLine($"nicht-statisch/{Name}: {s}");
        }
    }
    class Program
    {
        // ToDo: Realisieren Sie die folgenden Transformationen:
        //    *  Signature ( ... ) fügt der Nachricht eine Signatur an
        //    *  OldNewCorp ( ... ) ersetzt ZZZ durch AAA
        public static void OldNewCorp(ref string s)
        {
            s = s.Replace("ZZZ", "AAA");
        }
        public static void Signature(ref string s)
        {
            s += "\nNachricht vom AAA Server versendet";
        }
        //    *  Beautify ( ... ) ersetzt "liebe Kunden" durch "verehrte Kunden"
        static void Main(string[] args)
        {
            MsgServer server = new MsgServer();
            // ToDo: Fügen Sie einige Transformationen hinzu
            // msg --> OldNewCorp  --> Signature
            
            Client mueller = new Client("Müller");
            Client meier = new Client("Meier");
            Client huber = new Client("Huber");

            // ToDo: Registrieren Sie einige Listener 
            server.Notifier += Client.Ausgabe;
            server.Notifier += mueller.Listener;
            server.Notifier += meier.Listener;

            server.SendMsg("Herzlich Willkommen, liebe Kunden! ZZZ Corporation");

            // ToDo: Registrieren Sie weitere Listener an und entfernen
            //       Sie einen Listener
            server.Transformations += OldNewCorp;
            server.Transformations += Signature;

            // ToDo: Entfernen Sie die Signature Transformation
            server.SendMsg("Wir wünschen einen erfolgreichen Tag, liebe Kunden, ZZZ Corporation");
        }
    }
}
