﻿using System;
using System.Collections.Generic;
using System.Text;

namespace _12_UbgTransformingServer
{
    delegate void MeinDelegate(string notifier);
    delegate void Transform(ref string msg);
    class MsgServer
    {
        // ToDo: Notify-Event anlegen
        public event Action<string> Notifier;
        // ToDo: Transformations-Event anlegen
        public event Transform Transformations;

        public void SendMsg(string msg)
        {
            Console.WriteLine($"\n\n\nOriginal-Nachricht: {msg}");
            // ToDo: Alle in Transformations gespeicherten Transformationen anwenden
            Transformations?.Invoke(ref msg);
            Console.WriteLine($"Transformierte-Nachricht: {msg}");
            //    OldNewCorp(ref msg);   msg = OldNewCorp(msg);
            //    Signature(ref msg);    msg = Signature(msg);


            // ToDo: Den "transformierten" String an alle in Notify gespeicherten Listener versenden
            Notifier?.Invoke(msg);
        }
    }
}
